PROGRAM SCAD

USE nag_mat_inv, ONLY : nag_gen_mat_inv
USE nag_write_mat, ONLY : nag_write_gen_mat
USE nag_gen_lin_sys, ONLY : nag_gen_lin_sol
USE nag_examples_io, ONLY : nag_std_out
USE nag_rand_contin, ONLY : nag_rand_uniform, nag_rand_normal, nag_rand_gamma, nag_rand_mv_normal, nag_rand_seed_set, &
nag_seed_wp => nag_seed_dp
USE nag_rand_discrete, ONLY : nag_rand_seed_set, nag_rand_binom

IMPLICIT NONE

INTRINSIC KIND
 
character dummychara

!Declare Constants
REAL, PARAMETER    :: pi = 3.14159265, e = 0.0000001 
INTEGER, PARAMETER :: wp = KIND(1.0D0)
!Declare Variables
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE   :: beta, gamma, var_v, theta, v, yij, beta0, gamma0, var_v0, v0
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE   :: pl, dldbeta, dldgamma, delta0, delta, dlddelta, pm
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE   :: beta00, gamma00, var_v00, v00, xbeta00, wgamma00, mu0bar, mubar1
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE   :: delta00, deltamean, Sdmean, lpopt, mpopt, varmean, corridmean, bias, mumean, mubar
DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE :: corridbig, dldbetadgamma, dldbeta2, dldgamma2, x, mu0big
DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE :: varbig, sigma, dlddelta2, mI, deltabig, Sd, Sdbig, Sdelta, Sdinv, vbig, mubig 
REAL(wp), DIMENSION(:,:), ALLOCATABLE         :: matrix, x0, w
INTEGER, DIMENSION(:), ALLOCATABLE            :: m, yij_bin, yij_poi
INTEGER                                       :: distn, link, n, p_beta, p_gamma, summ, i, j, k, l, r, s, kl, ql, qm, summm, binn
INTEGER									      :: counter, counter1, counter2, sim, simcounter, loop1, loop2, simple, bg
INTEGER									      :: corrid0, incorrid0, corrid1, incorrid1, pmiss
DOUBLE PRECISION                              :: phi, summu0, sumvarmu0, sumvarmux0, sumb3, sumb4, sumd2dv, sumb31, sumb32, A1, A2
DOUBLE PRECISION                              :: A3, A4, A5, A6, A7, A8, alpha1, alpha2, sigmav, sigmae, likelihood, S2, bias1,bias2
REAL                                          :: lambdap, mup, lopt, mopt 
TYPE (nag_seed_wp)                            :: seed

!=============[INPUT VALUES]=====================

OPEN(UNIT = 1, FILE ='SimDataMiss.txt')

READ(1,*)dummychara,  distn
READ(1,*)dummychara,  link
READ(1,*)dummychara,  phi
READ(1,*)dummychara,  n
READ(1,*)dummychara,  p_beta
READ(1,*)dummychara,  p_gamma
READ(1,*)dummychara,  pmiss
READ(1,*)dummychara,  binn
READ(1,*)dummychara,  sigmav
READ(1,*)dummychara,  sigmae
READ(1,*)dummychara,  simcounter 
READ(1,*)dummychara,  simple

ALLOCATE(m(0:n))
ALLOCATE(beta(p_beta))
ALLOCATE(beta0(p_beta))
ALLOCATE(beta00(pmiss))
ALLOCATE(gamma(p_gamma))
ALLOCATE(gamma0(p_gamma))
ALLOCATE(gamma00(p_gamma))
ALLOCATE(var_v(n))
ALLOCATE(var_v0(n))
ALLOCATE(var_v00(n))
ALLOCATE(v(n))
ALLOCATE(v0(n))
ALLOCATE(v00(n))
ALLOCATE(wgamma00(n))
ALLOCATE(dldbeta(p_beta))
ALLOCATE(dldgamma(p_gamma))
ALLOCATE(dldbetadgamma(p_beta,p_gamma))
ALLOCATE(dldbeta2(p_beta,p_beta))
ALLOCATE(dldgamma2(p_gamma,p_gamma))
ALLOCATE(delta(p_beta+p_gamma))
ALLOCATE(delta0(p_beta+p_gamma))
ALLOCATE(delta00(pmiss+p_gamma))
ALLOCATE(dlddelta(p_beta+p_gamma))
ALLOCATE(dlddelta2(p_beta+p_gamma,p_beta+p_gamma))
ALLOCATE(pl(p_beta))
ALLOCATE(pm(p_gamma))
ALLOCATE(mI(p_beta+p_gamma,p_beta+p_gamma))
ALLOCATE(deltamean(p_beta+p_gamma))
ALLOCATE(deltabig(p_beta+p_gamma,simcounter))
ALLOCATE(Sdmean(p_beta+p_gamma))
ALLOCATE(Sd(p_beta+p_gamma,p_beta+p_gamma))
ALLOCATE(Sdbig(p_beta+p_gamma,simcounter))
ALLOCATE(Sdelta(p_beta+p_gamma,p_beta+p_gamma))
ALLOCATE(Sdinv(p_beta+p_gamma,p_beta+p_gamma))
ALLOCATE(lpopt(simcounter))
ALLOCATE(mpopt(simcounter))
ALLOCATE(varbig(n,simcounter))
ALLOCATE(vbig(n,simcounter))
ALLOCATE(varmean(n))
ALLOCATE(corridbig(24,simcounter))
ALLOCATE(corridmean(4))
ALLOCATE(bias(p_beta+p_gamma))

READ(1,*)dummychara,  m

summ = sum(m)

ALLOCATE(w(n,p_gamma))
ALLOCATE(x(summ,p_beta))
ALLOCATE(x0(summ,pmiss))
ALLOCATE(xbeta00(summ))
ALLOCATE(theta(summ))
ALLOCATE(yij(summ))
ALLOCATE(yij_bin(summ))
ALLOCATE(yij_poi(summ))
ALLOCATE(sigma(p_beta+p_gamma,p_beta+p_gamma))
ALLOCATE(mu0big(summ,simcounter))
ALLOCATE(mu0bar(simcounter))
ALLOCATE(mubig(summ,simcounter))
ALLOCATE(mumean(simcounter))
ALLOCATE(mubar(simcounter))
ALLOCATE(mubar1(simcounter))

CLOSE(UNIT = 1)

CALL nag_rand_seed_set(seed,4)

CALL MVN(summ,pmiss,0.5)

x0 = 0
x0 = matrix
x0(:,1) = 1

DEALLOCATE(matrix)

CALL MVN(n,p_gamma,0.5)

w = 0
w = matrix

DEALLOCATE(matrix)

OPEN(UNIT = 50, FILE ='SimBeta.txt')

READ(50,*)dummychara,  beta00

CLOSE(UNIT = 50)

OPEN(UNIT = 51, FILE ='SimGamma.txt')

READ(51,*)dummychara,  gamma00

CLOSE(UNIT = 51)

!=============[END INPUT VALUES]=====================

OPEN(UNIT = 60, FILE ='XMat.txt')
WRITE(UNIT = 60, FMT = '(f10.4)') x0  
CLOSE(UNIT = 60)

OPEN(UNIT = 61, FILE ='WMat.txt')
WRITE(UNIT = 61, FMT = '(f10.4)') w  
CLOSE(UNIT = 61)

alpha1 = 3.7 
alpha2 = 3.7

mI = 0

DO kl = 1,p_beta+p_gamma
   mI(kl,kl) = 0.0000000001
END DO

wgamma00 = matmul(w,gamma00)
var_v00 = exp(wgamma00) 
deltabig = 0
Sdbig = 0
varbig = 0
vbig = 0
mu0big = 0
mubig = 0
lpopt = 0
mpopt = 0 
delta00 = 0
delta00(1:pmiss) = beta00
delta00(pmiss+1:pmiss+p_gamma) = gamma00

OPEN(UNIT = 12, FILE ='Likelihood.txt')

CALL nag_rand_seed_set(seed,4)
      
DO sim = 1,simcounter

lambdap = 0 
mup = 0 
likelihood = 0
yij = 0
v00 = 0
counter = 0
xbeta00 = 0
wgamma00 = 0
var_v00 = 0
xbeta00 = matmul(x0,beta00)
wgamma00 = matmul(w,gamma00)
var_v00 = exp(wgamma00)
mu0big = 0

CALL SIMULATION()

x = 1

xbeta00 = 0
xbeta00 = matmul(x,beta00(1:1))
v00 = 0
summm = 0

!=====================[ESTIMATE V0]=========================!
DO i = 1,n
   summu0 = 0
   DO j = 1,m(i)
      summu0 = summu0 + yij(j+summm) - xbeta00(j+summm) 
   END DO
   v00(i) = (sigmav * summu0) / ((sigmav * m(i)) + sigmae) 
   summm = summm + m(i)
END DO   
!===========================[END]===========================!

DO loop1 = 1,5
   lambdap = lambdap + 0.2  
   mup = 0
   DO loop2 = 1,5
      mup = mup + 0.2

counter = counter + 1     
v0 = v00
beta0 = beta00(1)
gamma0 = gamma00
var_v0 = var_v00
delta0(1:p_beta) = beta00(1)
delta0(p_beta+1:p_beta+p_gamma) = gamma00

DO

!====================================[CALCULATE MLE OF V]==========================================!

CALL VEST()

!==============================================[END]===============================================!

CALL DEREST(var_v0)

CALL PAREST()

IF (counter1 == p_gamma) EXIT

delta0 = delta
beta0 = delta(1:p_beta)
gamma0 = delta(p_beta+1:p_beta+p_gamma)
v0 = v

END DO
  
bg = 0

DO kl = 1, p_beta+p_gamma
   IF (delta(kl) == 0) THEN
       bg = bg + 0
   ELSE
       bg = bg + 1    
   END IF
END DO   

var_v = 0
var_v = exp(matmul(w,gamma))

!======================================[MAXIMISED LIKELIHOOD]======================================!
CALL LEST(var_v)
!==============================================[END]===============================================!
 
  END DO
END DO

beta0 = 0 
gamma0 = 0
v = 0
var_v = 0
lambdap = 0
mup = 0
beta0 = deltabig(1:p_beta,sim) 
gamma0 = deltabig(1+p_beta:p_beta+p_gamma,sim)
delta = deltabig(:,sim)
v = vbig(:,sim)
var_v = varbig(:,sim)
lambdap = lpopt(sim)
mup = mpopt(sim)
!=======================================[VARIANCE ESTIMATION]======================================!
mubig(:,sim) = 0

CALL DEREST(var_v)

Sd = 0
Sdelta = 0
Sd = (n * sigma) - dlddelta2 + mI
 
CALL nag_gen_mat_inv(Sd)

Sdinv = 0
Sdinv = Sd
Sd = 0
Sd = (n * sigma) - dlddelta2 + mI
Sdelta = matmul(-dlddelta2,Sdinv) 

CALL nag_gen_lin_sol(Sd,Sdelta)

DO kl = 1, p_beta+p_gamma
   Sdbig(kl,sim) = sqrt(Sdelta(kl,kl))  
END DO

!==============================================[END]===============================================!

PRINT *, sim,'%' 

corrid0 = 0
corrid1 = 0
incorrid0 = 0
incorrid1 = 0

DO kl = 1,p_beta+p_gamma
   IF ((delta(kl)==0).and.(delta00(kl)==0)) THEN
      corrid0 = corrid0 + 1  
   ELSE IF ((delta(kl)/=0).and.(delta00(kl)/=0)) THEN
      corrid1 = corrid1 + 1
   ELSE IF ((delta(kl)==0).and.(delta00(kl)/=0)) THEN
      incorrid0 = incorrid0 + 1
   ELSE IF ((delta(kl)/=0).and.(delta00(kl)==0)) THEN
      incorrid1 = incorrid1 + 1
   END IF   
END DO

corridbig(1,sim) = corrid0
corridbig(2,sim) = corrid1
corridbig(3,sim) = incorrid0
corridbig(4,sim) = incorrid1

END DO

CLOSE(UNIT = 12)

deltamean = 0
Sdmean = 0

DO kl = 1,p_beta+p_gamma
   deltamean(kl) = sum(deltabig(kl,:)) / simcounter
   Sdmean(kl) = sum(Sdbig(kl,:)) / simcounter
END DO

DO i = 1,n
   varmean(i) = sum(varbig(i,:)) / simcounter
END DO

corridmean(1) = sum(corridbig(1,:)) / simcounter
corridmean(2) = sum(corridbig(2,:)) / simcounter
corridmean(3) = sum(corridbig(3,:)) / simcounter
corridmean(4) = sum(corridbig(4,:)) / simcounter

OPEN(UNIT = 62, FILE ='Mu0.txt')
WRITE(UNIT = 62, FMT = '(f15.10)') mu0big  
CLOSE(UNIT = 62)

OPEN(UNIT = 63, FILE ='Muhat.txt')
WRITE(UNIT = 63, FMT = '(f15.10)') mubig  
CLOSE(UNIT = 63)

mu0bar = 0
mubar = 0
mubar1 = 0
DO sim = 1,simcounter
   mu0bar(sim) = sum(mu0big(:,sim)) / summ
   mubar(sim) = sum(mubig(:,sim)) / summ
   mubar1(sim) = sum(abs(mu0big(:,sim)-mubig(:,sim))) / summ 
END DO

mumean = 0
DO sim = 1,simcounter
   mumean(sim) = abs(mu0bar(sim) - mubar(sim)) 
END DO

bias1 = 0
bias1 = sum(mumean) / simcounter

bias = 0
bias = (sum(mu0bar) - sum(mubar)) / simcounter

bias2 = 0
bias2 = sum(mubar1) / simcounter

PRINT *, 'delta00 =', delta00
PRINT *, 'deltamean =', deltamean   
PRINT *, 'se(delta) =', Sdmean
PRINT *, 'bias =', bias(1)
PRINT *, 'bias1 =', bias1
PRINT *, 'bias2 =', bias2
PRINT *, 'correctly - incorrectly identified =', corridmean
PRINT *, 'Likelihood =', likelihood

CONTAINS

!=============[SUBROUTINES]=====================

SUBROUTINE MVN(r1,r2,rho)

IMPLICIT NONE

INTRINSIC KIND
     
INTEGER, PARAMETER :: wp = KIND(1.0D0)
INTEGER :: i, nw, j
INTEGER, INTENT(IN) :: r1, r2
REAL, INTENT(IN) :: rho
REAL (wp), ALLOCATABLE :: a(:), c(:,:), chol(:)
            
nw = 0
nw = (r2*(r2+1))/2
     
ALLOCATE (a(r2),c(r2,r2),chol(nw),matrix(r1,r2)) ! Allocate storage
      
a = 0
DO i = 1,r2
   a(i) = 0.1*i
   DO j = 1,r2
      c(i,j) = rho**(abs(i-j))
   END DO   
END DO        
      
matrix = 0      
matrix(1,:) = nag_rand_mv_normal(seed,a,c=c,rel_tol=0.01_wp,chol=chol)

DO i = 2, r1
   matrix(i,:) = nag_rand_mv_normal(seed,a,chol=chol)
END DO

END SUBROUTINE MVN

FUNCTION VNORM(varvi) RESULT(vi)
	  
      IMPLICIT NONE
     
	  DOUBLE PRECISION, INTENT(IN) :: varvi   
      DOUBLE PRECISION :: vi
      
      vi = 0
      
      vi = nag_rand_normal(seed,b=varvi,brent=.FALSE.)
      
      OPEN(UNIT = 10, FILE ='VOutput.txt')
      WRITE(UNIT = 10, FMT = '(f10.4)') vi  
      
END FUNCTION VNORM

FUNCTION YNORM(mu_j, var_y_j) RESULT(y_ij)

      IMPLICIT NONE
     
	  DOUBLE PRECISION, INTENT(IN) :: mu_j, var_y_j   
      DOUBLE PRECISION             :: y_ij 
      
      y_ij = 0

      y_ij = nag_rand_normal(seed,a=mu_j,b=var_y_j,brent=.FALSE.)
      
      OPEN(UNIT = 11, FILE ='NormalOutput.txt')
      WRITE(UNIT = 11, FMT = '(f10.4)') y_ij    
      
END FUNCTION YNORM

FUNCTION YGAMMA(alphag_j, betag_j) RESULT(y_ij)
      
      IMPLICIT NONE
   
      DOUBLE PRECISION, INTENT(IN) :: alphag_j, betag_j 
      DOUBLE PRECISION             :: y_ij
      
      y_ij = 0

      y_ij = nag_rand_gamma(seed,a=alphag_j,b=betag_j)
      
END FUNCTION YGAMMA
 
SUBROUTINE YBIN(p_j, binn, y_ijbin)
     
      IMPLICIT NONE
      
      INTEGER, PARAMETER           :: r = 1
      CHARACTER (*), PARAMETER     :: fmt = '(/1x,a/(1X, 8i5))'
      INTEGER, INTENT(IN)          :: binn
      DOUBLE PRECISION, INTENT(IN) :: p_j
      
      INTEGER, DIMENSION(r)        :: y_ijbin
      
      CALL nag_rand_binom(binn,p_j,iv=y_ijbin,seed=seed)
   
END SUBROUTINE YBIN
  
FUNCTION UNI() RESULT(u)

       DOUBLE PRECISION :: u

       u = nag_rand_uniform(seed)
       
END FUNCTION UNI

SUBROUTINE SIMULATION()
  
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE   :: alphag, betag, lambda, theta00, mu00, var_mu00, var_y00, p
DOUBLE PRECISION                              :: F, G   
INTEGER, DIMENSION(1)					      :: y_ijbin

ALLOCATE(theta00(summ))
ALLOCATE(mu00(summ))
ALLOCATE(var_mu00(summ))
ALLOCATE(var_y00(summ))
ALLOCATE(alphag(summ))
ALLOCATE(betag(summ))
ALLOCATE(p(summ))
ALLOCATE(lambda(summ))

alphag = 0
betag = 0
p = 0
lambda = 0
summm = 0

DO i = 1,n  
   v00(i) = VNORM(var_v00(i))
      
     	!NORMAL DISTRIBUTION!
	 	IF (distn == 1) THEN 
	 	    DO j = 1,m(i)
	 	       theta00(j+summm) = xbeta00(j+summm) + v00(i)
	 	       mu00(j+summm) = theta00(j+summm)
         	   var_mu00(j+summm) = 1
         	   var_y00 = phi*var_mu00
	 	       yij(j+summm) = YNORM(mu00(j+summm), var_y00(j+summm)) 
	 	    END DO
	 	 
	 	!GAMMA DISTRIBUTION, EXPONENTIAL IF alpha = 1!
	 	ELSE IF (distn == 2) THEN
         	DO j = 1,m(i)
         	   theta00(j+summm) = xbeta00(j+summm) + v00(i)             	   
         	   alphag(j+summm) = 1/phi         	   
         	   IF (link == 1) THEN
         	       mu00(j+summm) = -1/theta00(j+summm)               
         	       var_mu00(j+summm) = mu00(j+summm)**2 
         	       betag(j+summm) = sqrt((-phi/theta00(j+summm))**2)         	   
         	   ELSE IF (link == 2) THEN
         	       betag(j+summm) = phi*exp(theta00(j+summm))
         	   END IF
         	   yij(j+summm) = YGAMMA(alphag(j+summm), betag(j+summm))
         	END DO
         	  
	 	!BINOMIAL DISTRIBUTION, BERNOULLI IF binn = 1!
	 	ELSE IF (distn == 3) THEN
         	DO j = 1,m(i)
         	   theta00(j+summm) = xbeta00(j+summm) + v00(i)
         	   mu00(j+summm) = binn*exp(theta00(j+summm))/(1 + exp(theta00(j+summm)))
         	   var_mu00(j+summm) = mu00(j+summm)*(binn - mu00(j+summm)) / binn
         	   p(j+summm) = mu00(j+summm) / binn 
	 	       CALL YBIN(p(j+summm), binn, y_ijbin)
	 	       yij_bin(j+summm) = y_ijbin(1)
	 	    END DO
	 	
	    !POISSON DISTRIBUTION!
	 	ELSE IF (distn == 4) THEN
         	DO j = 1,m(i)
         	   theta00(j+summm) = xbeta00(j+summm) + v00(i)
         	   mu00(j+summm) = exp(theta00(j+summm))
         	   var_mu00(j+summm) = mu00(j+summm)
         	   lambda(j+summm) = mu00(j+summm)
               
               !=============[POISSON]=====================
               
               G = exp(-lambda(j+summm))
               F = G
               yij_poi(j+summm) = 0
    
               DO 
                  IF (UNI() <= F) EXIT
             		 yij_poi(j+summm) = yij_poi(j+summm) + 1
             		 G = G * lambda(j+summm) / yij_poi(j+summm)
             		 F = F + G        
       		   END DO     

               !=============[END POISSON]=====================	 	       

	 	    END DO
         	   
	 	END IF      
    summm = summm + m(i) 
  END DO

mu0big(:,sim) = mu00 

END SUBROUTINE SIMULATION

SUBROUTINE VEST()

DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: xbeta0, wgamma0, theta0, mu0, var_mu0, var_y0

ALLOCATE(wgamma0(n))
ALLOCATE(xbeta0(summ))
ALLOCATE(theta0(summ))
ALLOCATE(mu0(summ))
ALLOCATE(var_mu0(summ))
ALLOCATE(var_y0(summ))

wgamma0 = 0
wgamma0 = matmul(w,gamma0)
xbeta0 = 0
xbeta0 = matmul(x,beta0)   

v = 0
summm = 0
summu0 = 0
theta0 = 0
mu0 = 0
var_mu0 = 0
var_y0 = 0
 
 DO i = 1,n 
            
    !NORMAL DISTRIBUTION!
    IF (distn == 1) THEN 
	  DO j = 1,m(i)
	 	 theta0(j+summm) = xbeta0(j+summm) + v0(i)
	 	 mu0(j+summm) = theta0(j+summm)
         var_mu0(j+summm) = 1
         var_y0 = phi * var_mu0
         summu0 = summu0 + yij(j+summm) - xbeta0(j+summm)
	  END DO	
	      
	!GAMMA DISTRIBUTION, EXPONENTIAL IF alpha = 1!
	ELSE IF (distn == 2) THEN
      DO j = 1,m(i)
         theta0(j+summm) = xbeta0(j+summm) + v0(i)             	            	   
         !IF (link == 1) THEN
         	 mu0(j+summm) = -1 / theta0(j+summm)
         !ELSE IF (link == 2) THEN
         	 !mu0(j+summm) = exp(theta0(j+summm))
         !END IF
         var_mu0(j+summm) = mu0(j+summm) ** 2
         var_y0 = phi * var_mu0
         summu0 = summu0 + yij(j+summm) - mu0(j+summm)          	
      END DO
         	  
	!BINOMIAL DISTRIBUTION, BERNOULLI IF binn = 1!
	ELSE IF (distn == 3) THEN
      DO j = 1,m(i)
         theta0(j+summm) = xbeta0(j+summm) + v0(i)
         mu0(j+summm) = binn * exp(theta0(j+summm))/(1 + exp(theta0(j+summm)))
         var_mu0(j+summm) = mu0(j+summm) * (binn - mu0(j+summm)) / binn 
	 	 summu0 = summu0 + yij(j+summm) - mu0(j+summm)
      END DO
	 	
	!POISSON DISTRIBUTION!
	ELSE IF (distn == 4) THEN
      DO j = 1,m(i)
         theta0(j+summm) = xbeta0(j+summm) + v0(i)
         mu0(j+summm) = exp(theta0(j+summm))
         var_mu0(j+summm) = mu0(j+summm)
	 	 summu0 = summu0 + yij(j+summm) - mu0(j+summm)	 	 
	  END DO
	 	          	   
	END IF

    v(i) = summu0 / (m(i) + (phi / var_v0(i))) 
    summu0 = 0 
    summm = summm + m(i)
   	
 END DO

END SUBROUTINE VEST

SUBROUTINE DEREST(varv)
 
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE   :: xbeta, wgamma, thetahat, bthetah, bthetah1, bthetah2, bthetah3, bthetah4
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE   :: dAdbeta, dAdgamma, dldv2, vvarv
DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE :: dthetadbeta, dthetadgamma, dvdbeta, dvdgamma, dvdbeta2
DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE :: dvdgamma2, dvdbetadgamma, dthetadbeta2, dthetadgamma2, dthetadbetadgamma 
DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE :: dAdbeta2, dAdgamma2, dAdbetadgamma, dvdbetadgammakl, wvarv, v2
DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE :: dthetadbetakr, dvdbetakr, dthetadgammals, dvdgammals, dthetadbetadgammakl
DOUBLE PRECISION, DIMENSION(:)                :: varv

ALLOCATE(wgamma(n))
ALLOCATE(dldv2(n))
ALLOCATE(dvdbeta(n,p_beta))
ALLOCATE(dvdgamma(n,p_gamma))
ALLOCATE(dvdbetadgamma(n,p_beta*p_gamma))
ALLOCATE(dvdbeta2(n,p_beta*p_beta))
ALLOCATE(dvdgamma2(n,p_gamma*p_gamma))
ALLOCATE(dAdbeta(p_beta))
ALLOCATE(dAdgamma(p_gamma))
ALLOCATE(dAdbeta2(p_beta,p_beta))
ALLOCATE(dAdgamma2(p_gamma,p_gamma))
ALLOCATE(dAdbetadgamma(p_beta,p_gamma))
ALLOCATE(vvarv(n))
ALLOCATE(wvarv(n,p_gamma))
ALLOCATE(v2(n,p_gamma))
ALLOCATE(dvdbetakr(n,p_beta*p_beta))
ALLOCATE(dvdgammals(n,p_gamma*p_gamma))
ALLOCATE(dvdbetadgammakl(n,p_beta*p_gamma))
ALLOCATE(xbeta(summ))
ALLOCATE(bthetah(summ))
ALLOCATE(bthetah1(summ))
ALLOCATE(bthetah2(summ))
ALLOCATE(bthetah3(summ))
ALLOCATE(bthetah4(summ))
ALLOCATE(thetahat(summ))
ALLOCATE(dthetadbeta(summ,p_beta))
ALLOCATE(dthetadgamma(summ,p_gamma))
ALLOCATE(dthetadbeta2(summ,p_beta*p_beta))
ALLOCATE(dthetadgamma2(summ,p_gamma*p_gamma))
ALLOCATE(dthetadbetadgamma(summ,p_beta*p_gamma))
ALLOCATE(dthetadbetakr(summ,p_beta*p_beta))
ALLOCATE(dthetadgammals(summ,p_gamma*p_gamma))
ALLOCATE(dthetadbetadgammakl(summ,p_beta*p_gamma))

summm = 0
thetahat = 0
bthetah = 0 
bthetah1 = 0 
bthetah2 = 0 
bthetah3 = 0 
bthetah4 = 0  
xbeta = 0
xbeta = matmul(x,beta0)
wgamma = 0
wgamma = matmul(w,gamma0) 

!====================================[CALCULATE THETA HAT - b(THETA)]==============================!
DO i = 1,n
   
  !NORMAL DISTRIBUTION!
  IF (distn == 1) THEN 
	DO j = 1,m(i)
       thetahat(j+summm) = xbeta(j+summm) + v(i)
       bthetah(j+summm) = (thetahat(j+summm)**2)/2
       bthetah1(j+summm) = thetahat(j+summm)
       bthetah2(j+summm) = 1
       bthetah3(j+summm) = 0 
       bthetah4(j+summm) = 0
	END DO
	 	    
  !GAMMA DISTRIBUTION, EXPONENTIAL IF alpha = 1!
  ELSE IF (distn == 2) THEN
    DO j = 1,m(i)
       thetahat(j+summm) = xbeta(j+summm) + v(i)
       bthetah(j+summm) = -log(-thetahat(j+summm))
       bthetah1(j+summm) = -1/thetahat(j+summm)
       bthetah2(j+summm) = 1/(thetahat(j+summm)**2)
       bthetah3(j+summm) = -2/(thetahat(j+summm)**3)
       bthetah4(j+summm) = 6/(thetahat(j+summm)**4)         	
    END DO
 
  !BINOMIAL DISTRIBUTION, BERNOULLI IF binn = 1!
  ELSE IF (distn == 3) THEN
    DO j = 1,m(i)
       thetahat(j+summm) = xbeta(j+summm) + v(i)
       bthetah(j+summm) = log(1+exp(thetahat(j+summm)))
       bthetah1(j+summm) = exp(thetahat(j+summm))/(1+exp(thetahat(j+summm)))
       bthetah2(j+summm) = exp(thetahat(j+summm))/((1+exp(thetahat(j+summm)))**2)
       bthetah3(j+summm) = (exp(thetahat(j+summm))-exp(2*thetahat(j+summm)))/((1+exp(thetahat(j+summm)))**3)
   bthetah4(j+summm) = (exp(thetahat(j+summm))-4*exp(2*thetahat(j+summm))+exp(3*thetahat(j+summm)))/((1+exp(thetahat(j+summm)))**4)
	END DO
	 	
  !POISSON DISTRIBUTION!
  ELSE IF (distn == 4) THEN
    DO j = 1,m(i)
	   thetahat(j+summm) = xbeta(j+summm) + v(i)
	   bthetah(j+summm) = exp(thetahat(j+summm))
	   bthetah1(j+summm) = exp(thetahat(j+summm))
	   bthetah2(j+summm) = exp(thetahat(j+summm))
	   bthetah3(j+summm) = exp(thetahat(j+summm))
	   bthetah4(j+summm) = exp(thetahat(j+summm))
	END DO
	 	          	   
  END IF	 
  summm = summm + m(i) 
END DO

mubig(:,sim) = bthetah1	 	          
!==============================================[END]===============================================!

dldv2 = 0

IF (simple==1) THEN
   dvdbeta = 0
   dthetadgamma = 0
   dvdgamma = 0
   dthetadbeta2 = 0
   dvdbeta2 = 0
   dthetadbetadgamma = 0
   dvdbetadgamma = 0
   dthetadgamma2 = 0
   dvdgamma2 = 0
   DO k = 1,p_beta
      summm = 0
      DO i = 1,n   
         sumvarmu0 = 0
         DO j = 1,m(i)
            sumvarmu0 = sumvarmu0 + bthetah2(j+summm)
            dthetadbeta(j+summm,k) = x(j+summm,k)
         END DO
         dldv2(i) = - ((sumvarmu0 / phi) + (1 / varv(i)))         
         summm = summm + m(i) 
      END DO
   END DO 

ELSE 

sumvarmu0 = 0
sumvarmux0 = 0
dvdbeta = 0
dldv2 = 0
dthetadbeta = 0

!====================================[CALCULATE DVDBETA - DTHETADBETA]=============================!
  DO k = 1,p_beta
     summm = 0
     DO i = 1,n   
        sumvarmu0 = 0
        sumvarmux0 = 0
        DO j = 1,m(i)
           sumvarmu0 = sumvarmu0 + bthetah2(j+summm)
           sumvarmux0 = sumvarmux0 + (bthetah2(j+summm) * x(j+summm,k))
        END DO
        IF (distn == 1) THEN 
           dvdbeta(i,k) = - sumvarmux0 / (m(i) + (phi / varv(i)))
        ELSE     
           dvdbeta(i,k) = - (varv(i) * sumvarmux0) / phi
        END IF   
        dldv2(i) = - ((sumvarmu0 / phi) + (1 / varv(i)))         
        DO j = 1,m(i)
           dthetadbeta(j+summm,k) = x(j+summm,k) + dvdbeta(i,k)
        END DO
     summm = summm + m(i) 
     END DO
  END DO
!==============================================[END]===============================================!

dvdbetadgamma = 0
dthetadbetadgamma = 0

!===========================[CALCULATE DVDBETADGAMMA - DTHETADBETADGAMMA]==========================!   
   DO k = 1,p_beta
      DO l = 1,p_gamma  
         DO i = 1,n
            IF (distn == 1) THEN 
               dvdbetadgamma(i,((k-1)*p_gamma)+l) = (w(i,l) * dvdbeta(i,k) * phi) / ((m(i) * varv(i)) + phi)
            ELSE     
               dvdbetadgamma(i,((k-1)*p_gamma)+l) = w(i,l) * dvdbeta(i,k) 
            END IF 
            dthetadbetadgamma(1+(i-1)*m(i-1):i*m(i),((k-1)*p_gamma)+l) = dvdbetadgamma(i,((k-1)*p_gamma)+l)   
         END DO        
      END DO   
   END DO
!==============================================[END]===============================================!

dvdbeta2 = 0
dthetadbeta2 = 0

!===============================[CALCULATE D2VDBETA2 - DTHETADBETA2]===============================!   
   DO k = 1,p_beta  
      DO r = 1,p_beta
         summm = 0 
         DO i = 1,n
            sumb3 = 0
            DO j = 1,m(i)    
               sumb3 = sumb3 + (bthetah3(j+summm) * x(j+summm,k) * x(j+summm,r))
            END DO
            dvdbeta2(i,((k-1)*p_beta)+r) = - (varv(i) * sumb3) / phi
            dthetadbeta2(1+(i-1)*m(i-1):i*m(i),((k-1)*p_beta)+r) = dvdbeta2(i,((k-1)*p_beta)+r)
            summm = summm + m(i)  
         END DO 
      END DO        
   END DO   
!==============================================[END]===============================================!

dvdgamma = 0
dthetadgamma = 0
dvdgamma2 = 0
dthetadgamma2 = 0

!================[CALCULATE DTHETADGAMMA - DVDGAMMA - DTHETADGAMMA2 - DVDGAMMA2]===================!   
   DO i = 1,n
      DO l = 1,p_gamma  
         IF (distn == 1) THEN 
            dvdgamma(i,l) = (w(i,l) * v(i) * phi) / ((m(i) * varv(i)) + phi) 
         ELSE     
            dvdgamma(i,l) = w(i,l) * v(i) 
         END IF
         dthetadgamma(1+(i-1)*m(i-1):i*m(i),l) = dvdgamma(i,l)
         DO s = 1,p_gamma
            A1 = 0
            A1 = (((m(i) * varv(i)) + phi) * dvdgamma(i,s)) - (w(i,s) * m(i) * varv(i) * v(i))
            IF (distn == 1) THEN 
               dvdgamma2(i,((l-1) * p_gamma)+s) = (w(i,l) * phi * A1) / (((m(i) * varv(i)) + phi) ** 2) 
            ELSE
               dvdgamma2(i,((l-1) * p_gamma)+s) = w(i,l) * w(i,s) * v(i)  
            END IF
            dthetadgamma2(1+(i-1)*m(i-1):i*m(i),((l-1) * p_gamma)+s) = dvdgamma2(i,((l-1) * p_gamma)+s)     
         END DO         
      END DO   
   END DO
!==============================================[END]===============================================!

END IF

dAdbeta = 0

!=======================================[CALCULATE DADBETA]========================================!    
  DO k = 1,p_beta
     summm = 0
     sumd2dv = 0
     DO i = 1,n
        sumb3 = 0
        DO j = 1,m(i)   
           sumb3 = sumb3 + (bthetah3(j+summm) * dthetadbeta(j+summm,k))
        END DO
        sumd2dv = sumd2dv + (sumb3 / dldv2(i))  
        summm = summm + m(i)
     END DO          
     dAdbeta(k) = sumd2dv / 2           
  END DO                             
!==============================================[END]===============================================!

 dAdgamma = 0

!=======================================[CALCULATE DADGAMMA]=======================================!   
  DO l = 1,p_gamma
     summm = 0
     sumd2dv = 0
     DO i = 1,n
        sumb3 = 0
        DO j = 1,m(i)   
           sumb3 = sumb3 + (bthetah3(j+summm) * dthetadgamma(j+summm,l))
        END DO
        sumb3 = sumb3 - (w(i,l) / varv(i))
        sumd2dv = sumd2dv + (sumb3 / dldv2(i))  
        summm = summm + m(i)
     END DO          
     dAdgamma(l) = sumd2dv / 2           
  END DO                             
!==============================================[END]===============================================!

dAdbeta2 = 0

!=======================================[CALCULATE DADBETA2]=======================================!   
DO k = 1,p_beta  
   DO r = 1,k
      summm = 0
      sumd2dv = 0
      DO i = 1,n
         sumb31 = 0
         sumb32 = 0
         sumb4 = 0
         DO j = 1,m(i)    
            A1 = 0
            A2 = 0
            sumb31 = sumb31 + (bthetah3(j+summm) * dthetadbeta(j+summm,k))
            sumb32 = sumb32 + (bthetah3(j+summm) * dthetadbeta(j+summm,r))
            A1 = (bthetah4(j+summm) * dthetadbeta(j+summm,k) * dthetadbeta(j+summm,r))
            A2 = (bthetah3(j+summm) * dvdbeta2(i,((k-1)*p_beta)+r))
            sumb4 = sumb4 + A1 + A2 
         END DO     
         sumd2dv = sumd2dv + (sumb4 / dldv2(i)) + ((sumb31 * sumb32) / (dldv2(i) ** 2))
         summm = summm + m(i)
      END DO        
      dAdbeta2(k,r) = sumd2dv / 2
      dAdbeta2(r,k) = dAdbeta2(k,r)   
   END DO        
END DO   
                               
!==============================================[END]===============================================!

dAdgamma2 = 0

!=======================================[CALCULATE DADGAMMA2]======================================!   
DO l = 1,p_gamma  
   DO s = 1,l
      summm = 0
      sumd2dv = 0
      DO i = 1,n
         sumb31 = 0
         sumb32 = 0
         sumb4 = 0
         A3 = 0
         DO j = 1,m(i)    
            sumb31 = sumb31 + (bthetah3(j+summm) * dthetadgamma(j+summm,l))
            sumb32 = sumb32 + (bthetah3(j+summm) * dthetadgamma(j+summm,s))
            A1 = 0
            A2 = 0
            A1 = (bthetah4(j+summm) * dthetadgamma(j+summm,l) * dthetadgamma(j+summm,s))
            A2 = (bthetah3(j+summm) * dvdgamma2(i,((l-1)*p_gamma)+s))
            sumb4 = sumb4 + A1 + A2 
         END DO     
         sumb31 = sumb31 - (w(i,l) / varv(i))
         sumb32 = sumb32 - (w(i,s) / varv(i))
         A3 = (w(i,l) * w(i,s)) / (varv(i))
         sumb4 = sumb4 + A3
         sumd2dv = sumd2dv + (sumb4 / dldv2(i)) + ((sumb31 * sumb32) / (dldv2(i) ** 2))
         summm = summm + m(i)
      END DO        
      dAdgamma2(l,s) = sumd2dv / 2   
      dAdgamma2(s,l) = dAdgamma2(l,s)  
   END DO        
END DO   
                               
!==============================================[END]===============================================!

dAdbetadgamma = 0

!====================================[CALCULATE DADBETADGAMMA]=====================================!   
DO k = 1,p_beta  
   DO l = 1,p_gamma
      summm = 0
      sumd2dv = 0
      DO i = 1,n
         sumb31 = 0
         sumb32 = 0
         sumb4 = 0
         DO j = 1,m(i)    
            A1 = 0
            A2 = 0
            sumb31 = sumb31 + (bthetah3(j+summm) * dthetadbeta(j+summm,k))
            sumb32 = sumb32 + (bthetah3(j+summm) * dthetadgamma(j+summm,l))
            A1 = (bthetah4(j+summm) * dthetadbeta(j+summm,k) * dthetadgamma(j+summm,l))
            A2 = (bthetah3(j+summm) * dvdbetadgamma(i,((k-1)*p_gamma)+l)) 
            sumb4 = sumb4 + A1 + A2
         END DO     
         sumb32 = sumb32 - (w(i,l) / varv(i))
         sumd2dv = sumd2dv + (sumb4 / dldv2(i)) + ((sumb31 * sumb32) / (dldv2(i) ** 2))
         summm = summm + m(i)
      END DO        
      dAdbetadgamma(k,l) = sumd2dv / 2  
   END DO        
END DO   
                               
!==============================================[END]===============================================!

vvarv = 0

DO i = 1,n
   vvarv(i) = v(i) / varv(i)
END DO   

dldbeta = 0

!=======================================[CALCULATE DLDBETA]========================================!   
  DO k = 1,p_beta
     dldbeta(k) = (dot_product(yij-bthetah1, dthetadbeta(:,k)) / phi) - dot_product(vvarv, dvdbeta(:,k)) + dAdbeta(k)     
  END DO                             
!==============================================[END]===============================================!

v2 = 0

DO l = 1,p_gamma
   DO i = 1,n
      v2(i,l) =  v(i) * w(i,l) / 2
   END DO
END DO

dldgamma = 0

!=======================================[CALCULATE DLDGAMMA]=======================================!
DO l = 1,p_gamma
   A1 = 0
   A2 = 0
   A1 = dot_product(yij-bthetah1, dthetadgamma(:,l)) / phi
   A2 = dot_product(vvarv, dvdgamma(:,l)-v2(:,l))
   dldgamma(l) = A1 - A2 - sum(w(:,l)) + dAdgamma(l)          
END DO

summm = 0
!==============================================[END]===============================================!

dthetadbetakr = 0
dvdbetakr = 0

DO k = 1,p_beta
   DO r = 1,k
      summm = 0
      DO i = 1,n
         DO j = 1,m(i)
            dthetadbetakr(j+summm,((k-1)*p_beta)+r) = dthetadbeta(j+summm,k) * dthetadbeta(j+summm,r)
         END DO
         dvdbetakr(i,((k-1)*p_beta)+r) = (dvdbeta(i,k) * dvdbeta(i,r)) / varv(i) 
         summm = summm + m(i)
      END DO
      dthetadbetakr(:,((r-1)*p_beta)+k) = dthetadbetakr(:,((k-1)*p_beta)+r)
      dvdbetakr(:,((r-1)*p_beta)+k) = dvdbetakr(:,((k-1)*p_beta)+r)
   END DO
END DO

dldbeta2 = 0
        
!=======================================[CALCULATE DLDBETA2]=======================================!
  DO k = 1,p_beta
     DO r = 1,k
        A1 = 0
        A2 = 0
        A3 = 0
        A4 = 0
        A5 = 0
        A1 = dot_product(yij-bthetah1, dthetadbeta2(:,((k-1)*p_beta)+r)) / phi
        A2 = dot_product(bthetah2, dthetadbetakr(:,((k-1)*p_beta)+r)) / phi
        A3 = dot_product(dvdbeta2(:,((k-1)*p_beta)+r), vvarv)
        A4 = sum(dvdbetakr(:,((k-1)*p_beta)+r))
        A5 = dAdbeta2(k,r)
        dldbeta2(k,r) = A1 - A2 - A3 - A4 + A5 
        dldbeta2(r,k) = dldbeta2(k,r)         
     END DO   
  END DO

!==============================================[END]===============================================!

dthetadgammals = 0
dvdgammals = 0
wvarv = 0

DO l = 1,p_gamma
   DO s = 1,l
      summm = 0
      DO i = 1,n
         DO j = 1,m(i)
            dthetadgammals(j+summm,((l-1)*p_gamma)+s) = dthetadgamma(j+summm,l) * dthetadgamma(j+summm,s)
         END DO
         dvdgammals(i,((l-1)*p_gamma)+s) = (dvdgamma(i,l) * dvdgamma(i,s)) / varv(i)
         summm = summm + m(i)
      END DO
      dthetadgammals(:,((s-1)*p_gamma)+l) = dthetadgammals(:,((l-1)*p_gamma)+s)
      dvdgammals(:,((s-1)*p_gamma)+l) = dvdgammals(:,((l-1)*p_gamma)+s)      
   END DO
END DO

DO l = 1,p_gamma
   DO i = 1,n
      wvarv(i,l) =  vvarv(i) * w(i,l)
   END DO
END DO

dldgamma2 = 0

!======================================[CALCULATE DLDGAMMA2]=======================================!
  DO l = 1,p_gamma
     DO s = 1,l
        A1 = 0
        A2 = 0
        A3 = 0
        A4 = 0
        A5 = 0
        A6 = 0
        A7 = 0
        A8 = 0
        A1 = dot_product(yij-bthetah1, dthetadgamma2(:,((l-1)*p_gamma)+s)) / phi
        A2 = dot_product(bthetah2, dthetadgammals(:,((l-1)*p_gamma)+s)) /phi
        A3 = dot_product(dvdgamma2(:,((l-1)*p_gamma)+s), vvarv)
        A4 = sum(dvdgammals(:,((l-1)*p_gamma)+s))
        A5 = dot_product(dvdgamma(:,l), wvarv(:,s))
        A6 = dot_product(dvdgamma(:,s), wvarv(:,l))
        A7 = dot_product(v2(:,l), wvarv(:,s))
        A8 = dAdgamma2(l,s)
        dldgamma2(l,s) = A1 - A2 - A3 - A4 + A5 + A6 - A7 + A8
        dldgamma2(s,l) = dldgamma2(l,s)
     END DO
  END DO                             
!==============================================[END]===============================================!

dthetadbetadgammakl = 0
dvdbetadgammakl = 0

DO k = 1,p_beta
   DO l = 1,p_gamma
      summm = 0
      DO i = 1,n
         DO j = 1,m(i)
            dthetadbetadgammakl(j+summm,((k-1)*p_gamma)+l) = dthetadbeta(j+summm,k) * dthetadgamma(j+summm,l)
         END DO
         dvdbetadgammakl(i,((k-1)*p_gamma)+l) = (dvdbeta(i,k) * dvdgamma(i,l)) / varv(i)
         summm = summm + m(i)
      END DO
   END DO
END DO

dldbetadgamma = 0
A1 = 0
A2 = 0
A3 = 0
A4 = 0
A5 = 0
A6 = 0

!====================================[CALCULATE DLDBETADGAMMA]=======================================!
  DO k = 1,p_beta
     DO l = 1,p_gamma
        A1 = dot_product(yij-bthetah1, dthetadbetadgamma(:,((k-1)*p_gamma)+l)) / phi
        A2 = dot_product(bthetah2, dthetadbetadgammakl(:,((k-1)*p_gamma)+l)) / phi
        A3 = dot_product(dvdbetadgamma(:,((k-1)*p_gamma)+l), vvarv)
        A4 = sum(dvdbetadgammakl(:,((k-1)*p_gamma)+l))
        A5 = dot_product(dvdbeta(:,k), wvarv(:,l))
        A6 = dAdbetadgamma(k,l)
        dldbetadgamma(k,l) = A1 - A2 - A3 - A4 + A5 + A6
        A1 = 0
        A2 = 0
        A3 = 0
        A4 = 0
        A5 = 0
        A6 = 0
     END DO
  END DO                             
!==============================================[END]===============================================!

pl = 0

DO k = 1,p_beta
   IF (abs(beta0(k)) <= lambdap) THEN
      pl(k) = lambdap
   ELSE IF ((lambdap < abs(beta0(k))) .and. (abs(beta0(k)) <= alpha1*lambdap)) THEN
      pl(k) = (alpha1*lambdap - abs(beta0(k))) / (alpha1 - 1)
   ELSE IF (abs(beta0(k)) > alpha1*lambdap) THEN
      pl(k) = 0
   END IF
END DO

pm = 0

DO l = 1,p_gamma
   IF (abs(gamma0(l)) <= mup) THEN
      pm(l) = mup
   ELSE IF ((mup < abs(gamma0(l))) .and. (abs(gamma0(l)) <= alpha2*mup)) THEN
      pm(l) = (alpha2*mup - abs(gamma0(l))) / (alpha2 - 1)
   ELSE IF (abs(gamma0(l)) > alpha2*mup) THEN
      pm(l) = 0
   END IF
END DO

sigma = 0

DO kl = 1,p_beta
   IF (beta0(kl) /= 0) THEN
   sigma(kl,kl) = pl(kl) / abs(beta0(kl))
   ELSE IF (beta0(kl) == 0) THEN
   sigma(kl,kl) = pl(kl) / abs(beta0(kl) + e)
   END IF
END DO

DO kl = p_beta+1, p_beta+p_gamma
   IF (gamma0(kl-p_beta) /= 0) THEN
   sigma(kl,kl) = pm(kl-p_beta) / abs(gamma0(kl-p_beta))
  ELSE IF (gamma0(kl-p_beta) == 0) THEN
   sigma(kl,kl) = pm(kl-p_beta) / abs(gamma0(kl-p_beta) + e)
  END IF
END DO

delta(1:p_beta) = beta
delta(p_beta+1:p_beta+p_gamma) = gamma 

dlddelta = 0

dlddelta(1:p_beta) = dldbeta
dlddelta(p_beta+1:p_beta+p_gamma) = dldgamma

dlddelta2 = 0

dlddelta2(1:p_beta,1:p_beta) = dldbeta2
dlddelta2(1+p_beta:p_gamma+p_beta,1+p_beta:p_gamma+p_beta) = dldgamma2
dlddelta2(1:p_beta,1+p_beta:p_gamma+p_beta) = dldbetadgamma 
dlddelta2(1+p_beta:p_gamma+p_beta,1:p_beta) = transpose(dldbetadgamma)

END SUBROUTINE DEREST

SUBROUTINE PAREST()

DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE   :: D
DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE :: C

ALLOCATE(C(p_beta+p_gamma,p_beta+p_gamma))
ALLOCATE(D(p_beta+p_gamma))
 
C = 0
D = 0
delta = 0

!For MPMLE, VPMLE and JPMLE
C = (n * sigma) - dlddelta2 + mI
D = dlddelta - matmul(dlddelta2,delta0) 

!For APMLE
!C = - dlddelta2 + mI
!D = dlddelta
 
CALL nag_gen_lin_sol(C,D)

!For MPMLE, VPMLE and JPMLE
delta = D

!For APMLE
!delta = delta0 + D
!========================================

A1 = 0 
A2 = 0

DO kl = 1,p_beta+p_gamma
   A1 = A1 + abs(delta0(kl))
END DO

A2 = 0.0001 * A1 

DO kl = 1,p_beta+p_gamma
   IF (abs(delta(kl)) < A2) THEN
       delta(kl) = 0 
   END IF
END DO

beta = delta(1:p_beta)
gamma = delta(p_beta+1:p_beta+p_gamma)

counter1 = 0
DO l = 1,p_gamma
   A1 = 0
   IF (gamma(l) /= 0) THEN
   A1 = (abs(gamma(l)-gamma0(l))) / (abs(gamma0(l)) + 0.0000000001)
   END IF
   IF (A1 > 0.1) EXIT
   counter1 = counter1 + 1
END DO

END SUBROUTINE PAREST

SUBROUTINE LEST(varv)
 
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: xbeta, wgamma, thetahat, bthetah, bthetah2, vvarv, ytheta, cphi, dldv2
DOUBLE PRECISION, DIMENSION(:)              :: varv

ALLOCATE(wgamma(n))
ALLOCATE(xbeta(summ))
ALLOCATE(thetahat(summ))
ALLOCATE(bthetah(summ))
ALLOCATE(bthetah2(summ))
ALLOCATE(vvarv(n))
ALLOCATE(ytheta(summ))
ALLOCATE(cphi(summ))
ALLOCATE(dldv2(n))

summm = 0
thetahat = 0
bthetah = 0 
bthetah2 = 0
xbeta = 0
xbeta = matmul(x,beta)
wgamma = 0
wgamma = matmul(w,gamma) 
cphi = 0
 
DO i = 1,n
 
  !NORMAL DISTRIBUTION!
  IF (distn == 1) THEN 
	DO j = 1,m(i)
       thetahat(j+summm) = xbeta(j+summm) + v(i)
       bthetah(j+summm) = (thetahat(j+summm)**2)/2
       bthetah2(j+summm) = 1
       cphi(j+summm) = - (((yij(j+summm)**2) / phi) + log(2*pi*phi)) / 2
	END DO
	 	    
  !GAMMA DISTRIBUTION, EXPONENTIAL IF alpha = 1!
  ELSE IF (distn == 2) THEN
    DO j = 1,m(i)
       thetahat(j+summm) = xbeta(j+summm) + v(i)
       bthetah(j+summm) = -log(-thetahat(j+summm))
       bthetah2(j+summm) = 1/(thetahat(j+summm)**2)        
    END DO
               	  
  !BINOMIAL DISTRIBUTION, BERNOULLI IF binn = 1!
  ELSE IF (distn == 3) THEN
    DO j = 1,m(i)
       thetahat(j+summm) = xbeta(j+summm) + v(i)
       bthetah(j+summm) = log(1+exp(thetahat(j+summm)))
       bthetah2(j+summm) = exp(thetahat(j+summm))/((1+exp(thetahat(j+summm)))**2)
    END DO
	 	
  !POISSON DISTRIBUTION!
  ELSE IF (distn == 4) THEN
    DO j = 1,m(i)
	   thetahat(j+summm) = xbeta(j+summm) + v(i)
	   bthetah(j+summm) = exp(thetahat(j+summm))
	   bthetah2(j+summm) = exp(thetahat(j+summm))
	END DO
	 	          	   
  END IF	 
  summm = summm + m(i) 
END DO	 	          

summm = 0
DO i = 1,n
   DO j = 1,m(i)
      ytheta(j+summm) = (yij(j+summm) * thetahat(j+summm)) - bthetah(j+summm) 
   END DO 
   summm = summm + m(i)
END DO

vvarv = 0
DO i = 1,n
   vvarv(i) = v(i) / varv(i)
END DO   

summm = 0
DO i = 1,n   
   sumvarmu0 = 0
   DO j = 1,m(i)
      sumvarmu0 = sumvarmu0 + bthetah2(j+summm)
   END DO
   dldv2(i) = - ((sumvarmu0 / phi) + (1 / varv(i)))         
   summm = summm + m(i) 
END DO

A1 = 0
summm = 0
DO i = 1,n
   DO j = 1,m(i)
      ytheta(j+summm) = ((yij(j+summm) * thetahat(j+summm)) - bthetah(j+summm)) 
   END DO 
   A1 = A1 + log(-dldv2(i)/(2*pi))                        
   summm = summm + m(i)
END DO

A2 = 0
A2 = - 2*((sum(ytheta)/phi) + (sum(cphi)) - (sum(wgamma)) - ((dot_product(vvarv,v) + A1)/2) - (n*log(2*pi))) + (bg*log(real(summ)))

WRITE(UNIT = 12, FMT = *) sim,lambdap,mup,A2,delta
 
IF (counter == 1) THEN
   likelihood = A2
   deltabig(:,sim) = delta
   varbig(:,sim) = varv
   vbig(:,sim) = v
   lpopt(sim) = lambdap
   mpopt(sim) = mup   
ELSE 
   IF (likelihood > A2) THEN
      likelihood = A2
      deltabig(:,sim) = delta 
      varbig(:,sim) = varv
      vbig(:,sim) = v
      lpopt(sim) = lambdap
      mpopt(sim) = mup
   END IF   
END IF
END SUBROUTINE LEST

END PROGRAM SCAD
